>From f105bbf4a9648816de5af7e85a510e3415c8105e Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?P=C3=A1draig=20Brady?=
Date: Wed, 17 Sep 2014 18:50:08 +0100
Subject: [PATCH 1/2] cp: issue correct warning and ignore duplicate source
dirs
* src/copy.c (copy_internal): Handle the case where we have the
same destination directory as already encountered, which can only
be due to the corresponding source directory being specified multiple
times.
* tests/cp/duplicate-sources.sh: Add a test for the new multiply
specified directory case, and the existing multiply specified file case.
* tests/local.mk: Reference the new test.
* NEWS: Mention the bug fix.
---
NEWS | 6 ++++++
src/copy.c | 11 +++++++++++
tests/cp/duplicate-sources.sh | 35 +++++++++++++++++++++++++++++++++++
tests/local.mk | 1 +
4 files changed, 53 insertions(+), 0 deletions(-)
create mode 100755 tests/cp/duplicate-sources.sh
diff --git a/NEWS b/NEWS
index ba0d3d7..ede5fd1 100644
--- a/NEWS
+++ b/NEWS
@@ -2,6 +2,12 @@ GNU coreutils NEWS -*- outline -*-
* Noteworthy changes in release ?.? (????-??-??) [?]
+** Bug fixes
+
+ cp no longer issues an incorrect warning about directory hardlinks when a
+ source directory is specified multiple times. Instead a warning is issued
+ and the duplicate source directory is skipped, as already the case for files.
+
** New features
chroot accepts the new --skip-chdir option to not change the working directory
diff --git a/src/copy.c b/src/copy.c
index a9561c6..4e0d266 100644
--- a/src/copy.c
+++ b/src/copy.c
@@ -2187,6 +2187,17 @@ copy_internal (char const *src_name, char const *dst_name,
*copy_into_self = true;
goto un_backup;
}
+ else if (same_name (dst_name, earlier_file))
+ {
+ error (0, 0, _("warning: source directory %s "
+ "specified more than once"),
+ quote (top_level_src_name));
+ /* We only do backups in move mode and for non dirs,
+ and in move mode this won't be the issue as the source will
+ be missing for subsequent attempts.
+ There we just warn and return here. */
+ return true;
+ }
else if (x->dereference == DEREF_ALWAYS)
{
/* This happens when e.g., encountering a directory for the
diff --git a/tests/cp/duplicate-sources.sh b/tests/cp/duplicate-sources.sh
new file mode 100755
index 0000000..e15c6d2
--- /dev/null
+++ b/tests/cp/duplicate-sources.sh
@@ -0,0 +1,35 @@
+#!/bin/sh
+# Ensure cp warns about but otherwise ignores source
+# items specified multiple times.
+
+# Copyright (C) 2014 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see .
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ cp
+
+mkdir a b || framework_failure_
+touch f || framework_failure_
+
+cp -a a a f f b 2>err || fail=1
+
+cat <exp
+cp: warning: source directory 'a' specified more than once
+cp: warning: source file 'f' specified more than once
+EOF
+
+compare exp err || fail=1
+
+Exit $fail
diff --git a/tests/local.mk b/tests/local.mk
index 1edaaf4..97bf5ed 100644
--- a/tests/local.mk
+++ b/tests/local.mk
@@ -427,6 +427,7 @@ all_tests = \
tests/cp/dir-rm-dest.sh \
tests/cp/dir-slash.sh \
tests/cp/dir-vs-file.sh \
+ tests/cp/duplicate-sources.sh \
tests/cp/existing-perm-dir.sh \
tests/cp/existing-perm-race.sh \
tests/cp/fail-perm.sh \
--
1.7.7.6
>From 469988c772a38c0e44bd7503ed5b98c8db4abea9 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?P=C3=A1draig=20Brady?=
Date: Thu, 18 Sep 2014 11:31:22 +0100
Subject: [PATCH 2/2] cp: fix handling of -H with multiply specified source
dirs
Following on from commit v5.92-729-g130dd06, also avoid
the erroneous directory hardlink warning with -H.
* src/copy.c (copy_internal): Also handle the -H case
for command line arguments.
* tests/cp/duplicate-sources.sh: Augment the test case.
* NEWS: Augment the news entry.
---
NEWS | 5 +++--
src/copy.c | 4 +++-
tests/cp/duplicate-sources.sh | 13 +++++++++++--
3 files changed, 17 insertions(+), 5 deletions(-)
diff --git a/NEWS b/NEWS
index ede5fd1..60117aa 100644
--- a/NEWS
+++ b/NEWS
@@ -5,8 +5,9 @@ GNU coreutils NEWS -*- outline -*-
** Bug fixes
cp no longer issues an incorrect warning about directory hardlinks when a
- source directory is specified multiple times. Instead a warning is issued
- and the duplicate source directory is skipped, as already the case for files.
+ source directory is specified multiple times. Now, consistent with other
+ file types, a warning is issued for source directories with duplicate names,
+ or with -H the directory is copied again using the symlink name.
** New features
diff --git a/src/copy.c b/src/copy.c
index 4e0d266..b7baee4 100644
--- a/src/copy.c
+++ b/src/copy.c
@@ -2198,7 +2198,9 @@ copy_internal (char const *src_name, char const *dst_name,
There we just warn and return here. */
return true;
}
- else if (x->dereference == DEREF_ALWAYS)
+ else if (x->dereference == DEREF_ALWAYS
+ || (command_line_arg
+ && x->dereference == DEREF_COMMAND_LINE_ARGUMENTS))
{
/* This happens when e.g., encountering a directory for the
second or subsequent time via symlinks when cp is invoked
diff --git a/tests/cp/duplicate-sources.sh b/tests/cp/duplicate-sources.sh
index e15c6d2..35b2e46 100755
--- a/tests/cp/duplicate-sources.sh
+++ b/tests/cp/duplicate-sources.sh
@@ -20,10 +20,19 @@
. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
print_ver_ cp
-mkdir a b || framework_failure_
+mkdir a || framework_failure_
touch f || framework_failure_
-cp -a a a f f b 2>err || fail=1
+# verify multiple files and dir sources only warned about
+mkdir dest || framework_failure_
+cp -a a a f f dest 2>err || fail=1
+rm -Rf dest || framework_failure_
+
+# verify multiple dirs and files with different names copied
+mkdir dest || framework_failure_
+ln -s a al || framework_failure_
+ln -s f fl || framework_failure_
+cp -aH a al f fl dest 2>>err || fail=1
cat <exp
cp: warning: source directory 'a' specified more than once
--
1.7.7.6